#include <hmg.ch>

PROCEDURE c_grid

   SET century on
   SET date german
   SET interactiveclose on
   SET multiple off warning
   SET navigation extended
   SET tooltipbackcolor { 193, 224, 255}
   SET tooltipstyle balloon

   DEFINE WINDOW win_grid ;
      AT 10, 10 ;
      WIDTH  600 ; 
      HEIGHT 600 ; 
      TITLE "grid definition" ;
      MODAL

      ON KEY ESCAPE ACTION win_grid.Release

          @ 060, 090 LABEL    grid_1 WIDTH 400   HEIGHT 30  VALUE 'mGrid( 070, 063, 640, 310 , Grid_3, STOCK ) ' FONT "Arial" SIZE 14  BOLD

          @ 110, 130 LABEL    grid_2 WIDTH 110   HEIGHT 30  VALUE "ROW" FONT "Arial" SIZE 12  BOLD
          @ 110, 290 TEXTBOX  grid_3 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 150, 131 LABEL    grid_4 WIDTH 110   HEIGHT 30  VALUE "COL" FONT "Arial" SIZE 12  BOLD
          @ 150, 290 TEXTBOX  grid_5 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  


          @ 191, 130 LABEL    grid_6 WIDTH 110   HEIGHT 30  VALUE "WIDTH" FONT "Arial" SIZE 12  BOLD
          @ 190, 290 TEXTBOX  grid_7 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 231, 130 LABEL    grid_8 WIDTH 110   HEIGHT 30  VALUE "HEIGHT" FONT "Arial" SIZE 12  BOLD
          @ 230, 290 TEXTBOX  grid_9 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  


          @ 271, 130 LABEL    grid_10 WIDTH 110   HEIGHT 30  VALUE "Grid_" FONT "Arial" SIZE 12  BOLD
          @ 270, 290 TEXTBOX  grid_11 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 311, 130 LABEL    grid_12 WIDTH 110   HEIGHT 30  VALUE "DataBase" FONT "Arial" SIZE 12  BOLD
          @ 310, 290 TEXTBOX  grid_13 WIDTH 100   HEIGHT 25  VALUE " " FONT "Arial" SIZE 11  BOLD UPPERCASE 


          @ 351, 130 LABEL    grid_14 WIDTH 110   HEIGHT 30  VALUE "WindowName" FONT "Arial" SIZE 12  BOLD
          @ 350, 290 TEXTBOX  grid_15 WIDTH 100   HEIGHT 25  VALUE " " FONT "Arial" SIZE 11  BOLD 
     
          @ 391, 130 LABEL    grid_16 WIDTH 110   HEIGHT 30  VALUE "Up-Down" FONT "Arial" SIZE 12  BOLD
          @ 390, 290 CHECKBOX grid_17 CAPTION ''  VALUE .F. 
         
          @ 500, 175 BUTTON grid_button ;
          CAPTION "OK" ;
          ACTION create_grid() ;
          WIDTH 100 ;
          HEIGHT 30 

          @ 500, 350 BUTTON button_monthexit ;
          CAPTION "CANCEL" ;
          ACTION win_grid.Release  ;
          WIDTH 100 ;
          HEIGHT 30 


   END WINDOW

   win_grid.grid_3.setfocus

   CENTER WINDOW win_grid
   ACTIVATE WINDOW win_grid

RETURN

*:---------------------------------------------*
PROCEDURE create_grid

 Local _result := '',  _crlf := chr(13)+chr(10)

 Local  DNomZ       := ALLTRIM(STR(win_grid.grid_11.value))
 Local  DCurZRow    := ALLTRIM(STR(win_grid.grid_3.value))   
 Local  DCurZCol    := ALLTRIM(STR(win_grid.grid_5.value))
 Local  DLasZWidth  := ALLTRIM(STR(win_grid.grid_7.value))
 Local  DLasZHeight := ALLTRIM(STR(win_grid.grid_9.value))
 Local  NumyZHeight := win_grid.grid_9.value + 50 
 Local  mTable      := ALLTRIM(win_grid.grid_13.value)
 Local  wName       := ALLTRIM(win_grid.grid_15.value)

*----------------------------------------------*

 IF win_grid.grid_13.value  <= SPACE(1)
    MsgStop("Missing DataBase","Attention")
    win_grid.grid_13.setfocus
    Return 
 ENDIF

 IF win_grid.grid_15.value  <= SPACE(1)
    MsgStop("Missing <WindowName>","Attention")
    win_grid.grid_15.setfocus
    Return 
 ENDIF
*----------------------------------------------*

 _result += '*---------------------------------  Grid --------------------------------------* ' + _crlf
 _result += '                                    ' + _crlf
 _result += ' PRIVATE mAlias     := ""           ' + _crlf
 _result += ' PRIVATE aFldnm     := {}           ' + _crlf                    
 _result += ' PRIVATE aWidth     := {}           ' + _crlf             
 _result += ' PRIVATE aStruct    := {}           ' + _crlf             
 _result += '                                    ' + _crlf
 _result += '*------------------------------------------------------------------------------* ' + _crlf
 _result += '*------------------------------------------------------------------------------* ' + _crlf
 _result += '                                    ' + _crlf
 _result += ' USE '+ mTable                        + _crlf
 _result += ' mAlias  := alias()                 ' + _crlf
 _result += ' aStruct := dbstruct()              ' + _crlf
 _result += '                                    ' + _crlf
 _result += ' For i = 1 to  LEN(aStruct)         ' + _crlf
 _result += '     aadd(aFldnm, aStruct[i, 1])    ' + _crlf
 _result += '     aadd(aWidth, aStruct[i, 3]*10) ' + _crlf
 _result += ' Next                               ' + _crlf
 _result += '                                    ' + _crlf
 _result += '*---------------------------------  Grid --------------------------------------* ' + _crlf
 _result += '                                    ' + _crlf
 _result += ' USE '+ mTable                        + _crlf
 _result += '                                    ' + _crlf
 _result += ' DEFINE GRID Grid_' + DNomZ           + _crlf       
 _result += '        ROW     ' +  DCurZRow         + _crlf         
 _result += '        COL     ' +  DCurZCol         + _crlf
 _result += '        WIDTH   ' +  DLasZWidth       + _crlf
 _result += '        HEIGHT  ' +  DLasZHeight      + _crlf
 _result += '        HEADERS  aFldnm             ' + _crlf    
 _result += '        WIDTHS   aWidth             ' + _crlf   
 _result += '        ITEMS { {""} }              ' + _crlf
 _result += '        VALUE Nil                   ' + _crlf
 _result += '        FONTNAME "Arial"            ' + _crlf
 _result += '        FONTSIZE 9                  ' + _crlf
 _result += '        TOOLTIP ""                  ' + _crlf
 _result += '        ONCHANGE Nil                ' + _crlf
 _result += '        ONGOTFOCUS Nil              ' + _crlf
 _result += '        ONLOSTFOCUS Nil             ' + _crlf
 _result += '        FONTBOLD .F.                ' + _crlf
 _result += '        FONTITALIC .F.              ' + _crlf
 _result += '        FONTUNDERLINE .F.           ' + _crlf
 _result += '        FONTSTRIKEOUT .F.           ' + _crlf
 _result += '        ONDBLCLICK Nil              ' + _crlf
 _result += '        ONHEADCLICK Nil             ' + _crlf
 _result += '        ONQUERYDATA Nil             ' + _crlf 
 _result += '        MULTISELECT .F.             ' + _crlf
 _result += '        ALLOWEDIT .F.               ' + _crlf
 _result += '        VIRTUAL .F.                 ' + _crlf
 _result += '        DYNAMICBACKCOLOR Nil        ' + _crlf
 _result += '        DYNAMICFORECOLOR Nil        ' + _crlf
 _result += '        COLUMNWHEN Nil              ' + _crlf
 _result += '        COLUMNVALID Nil             ' + _crlf
 _result += '        COLUMNCONTROLS  {}          ' + _crlf
 _result += '        SHOWHEADERS .T.             ' + _crlf
 _result += '        CELLNAVIGATION .F.          ' + _crlf
 _result += '        NOLINES .F.                 ' + _crlf
 _result += '        HELPID Nil                  ' + _crlf
 _result += '        IMAGE Nil                   ' + _crlf
 _result += '        JUSTIFY Nil                 ' + _crlf
 _result += '        ITEMCOUNT Nil               ' + _crlf
 _result += '        BACKCOLOR Nil               ' + _crlf
 _result += '        FONTCOLOR Nil               ' + _crlf
 _result += '        HEADERIMAGES Nil            ' + _crlf
 _result += '        ROWSOURCE mAlias            ' + _crlf
 _result += '        COLUMNFIELDS aFldnm         ' + _crlf
 _result += '        ALLOWAPPEND .F.             ' + _crlf
 _result += '        ALLOWDELETE .F.             ' + _crlf
 _result += '        BUFFERED .F.                ' + _crlf
 _result += '        DYNAMICDISPLAY Nil          ' + _crlf
 _result += '        ONSAVE Nil                  ' + _crlf
 _result += '        LOCKCOLUMNS Nil             ' + _crlf
 _result += ' END GRID                           ' + _crlf
 _result += '                                    ' + _crlf

IF win_grid.grid_17.Value = .T.
 _result += '    DEFINE BUTTON But_01               ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight)) + _crlf        
 _result += '           COL    100                  ' + _crlf
 _result += '           WIDTH  028                  ' + _crlf
 _result += '           HEIGHT 028                  ' + _crlf
 _result += '           CAPTION "<<"                ' + _crlf
 _result += '           PICTURE ""                  ' + _crlf  
 _result += '           TOOLTIP "First"             ' + _crlf
 _result += '           ACTION ( dBGoTop() , '+ wName + '.Grid_'+ DNomZ+'.RecNo := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                         ' + _crlf

 _result += '                                       ' + _crlf
 _result += '    DEFINE BUTTON But_02               ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight)) + _crlf        
 _result += '           COL    127                ' + _crlf
 _result += '           WIDTH  028                  ' + _crlf
 _result += '           HEIGHT 028                  ' + _crlf
 _result += '           CAPTION "<"                 ' + _crlf
 _result += '           PICTURE ""                  ' + _crlf  
 _result += '           TOOLTIP "Previous"          ' + _crlf
 _result += '           ACTION ( dBSkip ( -1 ) , '+ wName + '.Grid_'+ DNomZ+'.RecNo := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                         ' + _crlf
 _result += '                                       ' + _crlf

 _result += '    DEFINE BUTTON But_03               ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight)) + _crlf        
 _result += '           COL    155               ' + _crlf
 _result += '           WIDTH  028                  ' + _crlf
 _result += '           HEIGHT 028                  ' + _crlf
 _result += '           CAPTION ">"                 ' + _crlf
 _result += '           PICTURE ""                  ' + _crlf  
 _result += '           TOOLTIP "Next"              ' + _crlf
 _result += '           ACTION ( dBSkip (1) , if ( Eof() , DbGoBottom() , Nil ) ,'+ wName + '.Grid_'+ DNomZ+'.RecNo := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                         ' + _crlf
 _result += '                                       ' + _crlf

 _result += '    DEFINE BUTTON But_04               ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight)) + _crlf        
 _result += '           COL    182                  ' + _crlf
 _result += '           WIDTH  028                  ' + _crlf
 _result += '           HEIGHT 028                  ' + _crlf
 _result += '           CAPTION ">>"                 ' + _crlf
 _result += '           PICTURE ""                  ' + _crlf  
 _result += '           TOOLTIP "Lastt"              ' + _crlf
 _result += '           ACTION  ( dBGoBottom() , '+ wName + '.Grid_'+ DNomZ+'.RecNo := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                         ' + _crlf
 _result += '                                       ' + _crlf
ENDIF
 _result += '    HMG_ChangeWindowStyle ( GetControlHandle("Grid_' + DNomZ +'","'+ wName +'") , LVS_REPORT, NIL, .T. ) ' + _crlf 
 _result += '                                       ' + _crlf

 System.Clipboard := _result
 
 msginfo(_result)

Return  Nil 

