#include <hmg.ch>

PROCEDURE c_listbox

   SET century on
   SET date german
   SET interactiveclose on
   SET multiple off warning
   SET navigation extended
   SET tooltipbackcolor { 193, 224, 255}
   SET tooltipstyle balloon

   DEFINE WINDOW win_listbox ;
      AT 10, 10 ;
      WIDTH 600 ; 
      HEIGHT 600 ; 
      TITLE "LISTBOX definition" ;
      MODAL 

      ON KEY ESCAPE ACTION win_listbox.Release
 
 /*
        @ <nRow> ,<nCol>
            LISTBOX <ControlName>
            [ OF | PARENT <ParentWindowName> ]
            WIDTH <nWidth>
            HEIGHT <nHeight>
            [ ITEMS <acItems> ]
            [ VALUE <nValue> ]
            [ FONT <cFontName> SIZE <nFontSize> ]
            [ BOLD ] [ ITALIC ] [ UNDERLINE ] [ STRIKEOUT ]
            [ TOOLTIP <cToolTipText> ]   
            [ BACKCOLOR <aBackColor> ]
            [ FONTCOLOR <aFontColor> ]
            [ ON GOTFOCUS <OnGotFocusProcedur> | <bBlock> ]
            [ ON CHANGE <OnChangeProcedure> | <bBlock> ]   
            [ ON LOSTFOCUS <OnLostFocusProcedur> | <bBlock> ]
            [ ON DBLCLICK <OnDblClickProcedure> | bBlock> ]
            [ MULTISELECT ]
            [ HELPID <nHelpId> ]
            [ BREAK ]
            [ INVISIBLE ]
            [ NOTABSTOP ]
            [ SORT ]
            [ DRAGITEMS ]  
 */
 
	  @ 50, 50 LABEL listbox_1 VALUE '@' BOLD
	  @ 50, 70 TEXTBOX listbox_2 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '9999'
	  @ 50, 115 LABEL listbox_3 VALUE ','
	  @ 50, 120 TEXTBOX listbox_4 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '9999'
	  @ 50, 170 LABEL listbox_5 VALUE 'LISTBOX' WIDTH 70 BOLD
	  @ 50, 250 TEXTBOX listbox_6 WIDTH 150 VALUE 'listbox_1'
	  
	  @ 80, 100 LABEL listbox_7 VALUE 'WIDTH' WIDTH 70 BOLD
          @ 80, 180 TEXTBOX listbox_8 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '999'
	  @ 80, 230 LABEL listbox_9 VALUE 'HEIGHT' WIDTH 70 BOLD
          @ 80, 310 TEXTBOX listbox_10 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '999'

	  @ 110, 100 LABEL listbox_11 VALUE 'ITEMS' WIDTH 70
          @ 110, 180 TEXTBOX listbox_12 WIDTH 50 VALUE 5 NUMERIC INPUTMASK '999'
	  @ 110, 240 LABEL listbox_13 VALUE 'TIMES' WIDTH 70

	  @ 140, 100 LABEL listbox_14 VALUE 'VALUE' WIDTH 70
          @ 140, 180 TEXTBOX listbox_15 WIDTH 50 VALUE 1 NUMERIC INPUTMASK '999'
	  
	  @ 170, 100 LABEL listbox_16 VALUE 'FONT' WIDTH 70
          @ 170, 180 TEXTBOX listbox_17 WIDTH 40 VALUE 'Arial'
	  @ 170, 230 LABEL listbox_18 VALUE 'SIZE' WIDTH 70
          @ 170, 310 TEXTBOX listbox_19 WIDTH 40 VALUE 10 NUMERIC INPUTMASK '999'
			
         @ 200, 100 RADIOGROUP listbox_20 ;
			OPTIONS { 'BOLD', 'ITALIC' , 'UNDERLINE' , 'STRIKEOUT', 'NONE' } ;
			VALUE 5 ;
			WIDTH 100 ;
			HORIZONTAL ;
			SPACING 100

	  @ 230, 70 LABEL listbox_21 VALUE 'TOOLTIP' WIDTH 100
	  @ 230, 180 TEXTBOX listbox_22 WIDTH 150 
	
	  @ 260, 70 LABEL listbox_23 VALUE 'ON GOTFOCUS' WIDTH 100
	  @ 260, 180 TEXTBOX listbox_24 WIDTH 150
	  
	  @ 290, 70 LABEL listbox_25 VALUE 'ON CHANGE' WIDTH 100
	  @ 290, 180 TEXTBOX listbox_26 WIDTH 150

	  @ 320, 70 LABEL listbox_27 VALUE 'ON LOSTFOCUS' WIDTH 100
	  @ 320, 180 TEXTBOX listbox_28 WIDTH 150 

	  @ 350, 70 LABEL listbox_29 VALUE 'ON DBLCLICK' WIDTH 100
	  @ 350, 180 TEXTBOX listbox_30 WIDTH 150
 
          @ 380, 100 CHECKBOX listbox_31 CAPTION 'MULTISELECT' WIDTH 100 HEIGHT 30 
          @ 380, 200 CHECKBOX listbox_32 CAPTION 'BREAK' WIDTH 100 HEIGHT 30 
          @ 380, 300 CHECKBOX listbox_33 CAPTION 'INVISIBLE' WIDTH 100 HEIGHT 30 
	  
          @ 410, 100 CHECKBOX listbox_34 CAPTION 'NOTABSTOP' WIDTH 100 HEIGHT 30 
          @ 410, 200 CHECKBOX listbox_35 CAPTION 'SORT' WIDTH 100 HEIGHT 30 
          @ 410, 300 CHECKBOX listbox_36 CAPTION 'DRAGITEMS' WIDTH 100 HEIGHT 30 
  
          @ 500, 175 BUTTON listbox_button ;
          CAPTION "OK" ;
          ACTION create_listbox() ;
          WIDTH 100 ;
          HEIGHT 30 

          @ 500, 350 BUTTON button_listexit ;
          CAPTION "CANCEL" ;
          ACTION win_listbox.Release  ;
          WIDTH 100 ;
          HEIGHT 30 
	

   END WINDOW

   CENTER WINDOW win_listbox
   ACTIVATE WINDOW win_listbox

RETURN
*:---------------------------------------------*
PROCEDURE create_listbox

LOCAL _result := '', _sep := '', _charsep := "'", _crlf := chr(13)+chr(10), _i
LOCAL _count := Win_listbox.listbox_12.Value
  
 _result += '   @ ' + alltrim(str(Win_listbox.listbox_2.Value)) + ', ' + alltrim(str(Win_listbox.listbox_4.Value)) + ' LISTBOX '
 _result += alltrim(win_listbox.listbox_6.Value) + ' ; ' + _crlf

 if win_listbox.listbox_8.Value != 0
    _result += '      WIDTH ' + alltrim(str(win_listbox.listbox_8.Value)) + ' ; ' + _crlf
 endif
 
 if win_listbox.listbox_10.Value != 0
    _result += '      HEIGHT ' + alltrim(str(win_listbox.listbox_10.Value)) + ' ; ' + _crlf
 endif

 _result += '      ITEMS { '
 for _i = 1 to _count-1
    _result += _charsep + 'List' + alltrim(str(_i)) + _charsep + ', '
 next
 _result += _charsep + 'List' + alltrim(str(_count)) + _charsep + ' } ; ' + _crlf
 
    _result += '      VALUE ' + alltrim(str(win_listbox.listbox_15.Value)) + ' ; ' + _crlf
 
if !empty(win_listbox.listbox_17.Value)
    _result += '      FONT ' +_charsep + alltrim(win_listbox.listbox_17.Value) + _charsep
	_result += ' SIZE ' + alltrim(str(win_listbox.listbox_19.Value))+ ' ; ' + _crlf
 endif

 if win_listbox.listbox_20.Value = 1
    _result += '      BOLD ; ' + _crlf
 endif
 if win_listbox.listbox_20.Value = 2
    _result += '      ITALIC ; ' + _crlf
 endif
 if win_listbox.listbox_20.Value = 3
    _result += '      UNDERLINE ; ' + _crlf
 endif
 if win_listbox.listbox_20.Value = 4
    _result += '      STRIKEOUT ; ' + _crlf
 endif
 
 if !empty(win_listbox.listbox_22.Value) 
     _result += '      TOOLTIP ' + _charsep + alltrim(win_listbox.listbox_22.Value) + _charsep + ' ; ' + _crlf
 endif

*------------------------------------------------
    _result +='      BACKCOLOR NIL ;'  + _crlf
    _result +='      FONTCOLOR NIL ;'  + _crlf
*------------------------------------------------

 if !empty(win_listbox.listbox_24.Value) 
     _result += '      ON GOTFOCUS ' + alltrim(win_listbox.listbox_22.Value) + ' ; ' + _crlf
 endif
if !empty(win_listbox.listbox_26.Value) 
     _result += '      ON CHANGE ' + alltrim(win_listbox.listbox_22.Value) + ' ; ' + _crlf
 endif
if !empty(win_listbox.listbox_28.Value) 
     _result += '      ON LOSTFOCUS ' + alltrim(win_listbox.listbox_22.Value) + ' ; ' + _crlf
 endif
if !empty(win_listbox.listbox_30.Value) 
     _result += '      ON DBLCLICK ' + alltrim(win_listbox.listbox_22.Value) + ' ; ' + _crlf
 endif

if win_listbox.listbox_31.Value
     _result += '      MULTISELECT ; ' + _crlf
 endif
if win_listbox.listbox_32.Value
     _result += '      BREAK ; ' + _crlf
 endif
if win_listbox.listbox_33.Value
     _result += '      INVISIBLE ; ' + _crlf
 endif

 if win_listbox.listbox_34.Value
     _result += '      NOTABSTOP ; ' + _crlf
 endif
if win_listbox.listbox_35.Value
     _result += '      SORT ; ' + _crlf
 endif
if win_listbox.listbox_36.Value
     _result += '      DRAGITEMS ; ' + _crlf
 endif
 
 
 
 
_result += _crlf


 System.Clipboard := _result
 
 msginfo(_result)
 
 RETURN
