#include <hmg.ch>

PROCEDURE c_progressbar

   SET century on
   SET date german
   SET interactiveclose on
   SET multiple off warning
   SET navigation extended
   SET tooltipbackcolor { 193, 224, 255}
   SET tooltipstyle balloon

   DEFINE WINDOW win_progressbar ;
      AT 10, 10 ;
      WIDTH 600 ; 
      HEIGHT 600 ; 
      TITLE "PROGRESSBAR definition" ;
      MODAL

      ON KEY ESCAPE ACTION win_progressbar.Release

/*
       @ <nRow> ,<nCol>
            PROGRESSBAR<ControlName>
            [ OF | PARENT <ParentWindowName> ]
            RANGE <nRangeMin> , <nRangeMax>
            [ WIDTH <nWidth> ]
            [ HEIGHT <nHeight> ] 
            [ TOOLTIP <cToolTipText> ]
            [ VERTICAL ]
            [ SMOOTH ]  
            [ HELPID <nHelpId> ]
            [ BACKCOLOR <aBackColor> ]
            [ FORECOLOR <aForeColor> ]
*/	 
	  
	  @ 50, 50 LABEL progressbar_1 VALUE '@' BOLD
	  @ 50, 70 TEXTBOX progressbar_2 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '9999'
	  @ 50, 115 LABEL progressbar_3 VALUE ','
	  @ 50, 120 TEXTBOX progressbar_4 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '9999'
	  @ 50, 170 LABEL progressbar_5 VALUE 'PROGRESSBAR' WIDTH 100 BOLD
	  @ 50, 280 TEXTBOX progressbar_6 WIDTH 150 VALUE 'progressbar_1'

	  @ 80, 100 LABEL progressbar_7a VALUE 'RANGE' WIDTH 70 BOLD
          @ 80, 180 TEXTBOX progressbar_7 WIDTH 40 VALUE 0 NUMERIC INPUTMASK '9999'
          @ 80, 225 LABEL progressbar_8a VALUE ','
	  @ 80, 250 TEXTBOX progressbar_8 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '9999'
	  	  
	  @ 110, 100 LABEL progressbar_9 VALUE 'WIDTH' WIDTH 70 BOLD
          @ 110, 180 TEXTBOX progressbar_10 WIDTH 40 VALUE 200 NUMERIC INPUTMASK '999'
	  @ 110, 230 LABEL progressbar_11 VALUE 'HEIGTH' WIDTH 70 BOLD
          @ 110, 310 TEXTBOX progressbar_12 WIDTH 40 VALUE 20  NUMERIC INPUTMASK '999'
	  
	  @ 140, 100 LABEL progressbar_13 VALUE 'TOOLTIP' WIDTH 70
	  @ 140, 180 TEXTBOX progressbar_14 WIDTH 150 
	  
	  @ 170, 100 CHECKBOX progressbar_15 CAPTION 'VERTICAL' 
          @ 200, 100 CHECKBOX progressbar_16 CAPTION 'SMOOTH' 
	  
	  @ 250, 100 CHECKBOX progressbar_17 CAPTION 'TEST BUTTON & FUNCTION' 


          @ 500, 175 BUTTON progressbar_button ;
          CAPTION "OK" ;
          ACTION create_progressbar() ;
          WIDTH 100 ;
          HEIGHT 30 

          @ 500, 350 BUTTON button_progresexit ;
          CAPTION "CANCEL" ;
          ACTION win_progressbar.Release  ;
          WIDTH 100 ;
          HEIGHT 30 		
	 

   END WINDOW

   CENTER WINDOW win_progressbar
   ACTIVATE WINDOW win_progressbar

RETURN
*:---------------------------------------------*
PROCEDURE create_progressbar

LOCAL _result := '   @ ', _sep := '', _charsep := "'", _crlf := chr(13)+chr(10)
 
 _result += alltrim(str(win_progressbar.progressbar_2.Value)) + ', ' + alltrim(str(win_progressbar.progressbar_2.Value)) + ' PROGRESSBAR '
 _result += alltrim(win_progressbar.progressbar_6.Value) + ' ; ' + _crlf
  
    _result += '      RANGE ' + alltrim(str(win_progressbar.progressbar_7.Value)) + ', ' + alltrim(str(win_progressbar.progressbar_8.Value)) + ' ; ' + _crlf
 
  
 if win_progressbar.progressbar_10.Value != 0
    _result += '      WIDTH ' + alltrim(str(win_progressbar.progressbar_10.Value)) + ' ; ' + _crlf
 endif
 
 if win_progressbar.progressbar_12.Value != 0
    _result += '      HEIGHT ' + alltrim(str(win_progressbar.progressbar_12.Value)) + ' ; ' + _crlf
 endif
    
 if !empty(win_progressbar.progressbar_14.Value)
    _result += '      TOOLTIP ' + _charsep + alltrim(win_progressbar.progressbar_14.Value) + _charsep + ' ; ' + _crlf
 endif

*------------------------------------------------
    _result +='      BACKCOLOR NIL ;'  + _crlf
    _result +='      FONTCOLOR NIL ;'  + _crlf
*------------------------------------------------
 
 if win_progressbar.progressbar_15.Value 
    _result += '      VERTICAL ; ' + _crlf
 endif
 if win_progressbar.progressbar_16.Value 
    _result += '      SMOOTH ; ' + _crlf
 endif
  
 if win_progressbar.progressbar_17.Value 
    _result += _crlf
 
    _result += '      @ ' + alltrim(str(win_progressbar.progressbar_2.Value+50)) + ', ' + alltrim(str(win_progressbar.progressbar_4.Value+50)) 
	_result += ' BUTTON test_1 CAPTION ' + _charsep + 'Run Test' + _charsep + ' ; ' + _crlf
	_result += '         WIDTH 80 HEIGHT 25  ; ' + _crlf
    _result += '         ACTION nil // runtest() ' + _crlf + _crlf
 
    _result += '/*** copy this in function area ***' + _crlf
	_result += 'FUNCTION runtest()' + _crlf + _crlf
 
    _result += 'for i = 1  to 100' + _crlf
    _result += '   window_1.progressbar_1.Value := i' + _crlf
    _result += '   do events' + _crlf
    _result += '   inkey( .01 )' + _crlf
    _result += 'next ' + _crlf
 
    _result += _crlf + 'RETURN ' + _crlf
	
    _result += '******************************** */' + _crlf + _crlf
 
 endif
 
 
 
 

 System.Clipboard := _result
 
 msginfo(_result)
 
 RETURN
