#include <hmg.ch>

PROCEDURE c_window

   SET century on
   SET date german
   SET interactiveclose on
   SET multiple off warning
   SET navigation extended
   SET tooltipbackcolor { 193, 224, 255}
   SET tooltipstyle balloon

   DEFINE WINDOW win_window ;
      AT 10, 10 ;
      WIDTH 600 ; 
      HEIGHT 600 ; 
      TITLE "WINDOW definition" ;
      MODAL

      ON KEY ESCAPE ACTION win_window.Release
	  
	  @ 50, 50 LABEL window_1 VALUE 'DEFINE WINDOW' BOLD
	  @ 50, 180 TEXTBOX window_2 WIDTH 150 VALUE 'window_1'
	  	  
	  @ 80, 100 LABEL window_3 VALUE 'AT' BOLD
	  @ 80, 130 TEXTBOX window_4 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '9999'
	  @ 80, 175 LABEL window_5 VALUE ','
	  @ 80, 180 TEXTBOX window_6 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '9999'
	  
	  @ 110, 100 LABEL window_7 VALUE 'WIDTH' WIDTH 70 BOLD
          @ 110, 180 TEXTBOX window_8 WIDTH 40 VALUE 800 NUMERIC INPUTMASK '9999'
	  @ 110, 230 LABEL window_9 VALUE 'HEIGHT' WIDTH 70 BOLD
          @ 110, 310 TEXTBOX window_10 WIDTH 40 VALUE 600 NUMERIC INPUTMASK '9999'

	  @ 140, 100 LABEL window_11 VALUE 'TITLE' WIDTH 70
          @ 140, 180 TEXTBOX window_12 WIDTH 200 
	  
	  @ 170, 100 LABEL window_13 VALUE 'ICON' WIDTH 70
	  @ 170, 180 TEXTBOX window_14 WIDTH 100 
			
          @ 200, 100 RADIOGROUP window_15 ;
			OPTIONS { 'MAIN', 'CHILD' , 'MODAL' , 'SPLITCHILD', 'PANEL' } ;
			VALUE 1 ;
			WIDTH 100 ;
			HORIZONTAL ;
			SPACING 100

      @ 230, 100 CHECKBOX window_16 CAPTION 'NOSHOW' 
      @ 230, 250 CHECKBOX window_17 CAPTION 'TOPMOST' 
      @ 230, 400 CHECKBOX window_18 CAPTION 'NOAUTORELEASE'    

      @ 260, 100 CHECKBOX window_19 CAPTION 'NOMINIMIZE' 
      @ 260, 250 CHECKBOX window_20 CAPTION 'NOMAXIMIZE' 
      @ 260, 400 CHECKBOX window_21 CAPTION 'NOSIZE' 
			
      @ 290, 100 CHECKBOX window_22 CAPTION 'NOSYSMENU' 
      @ 290, 250 CHECKBOX window_23 CAPTION 'NOCAPTION' 

	  @ 320, 70 LABEL window_24 VALUE 'ON INIT' WIDTH 100
	  @ 320, 180 TEXTBOX window_25 WIDTH 150
	  
	  @ 350, 70 LABEL window_26 VALUE 'ON RELEASE' WIDTH 100
	  @ 350, 180 TEXTBOX window_27 WIDTH 150

	  @ 380, 70 LABEL window_28 VALUE 'BACKGROUND' WIDTH 100
	  @ 380, 180 TEXTBOX window_29 WIDTH 150
	  
          @ 410, 100 CHECKBOX window_30 CAPTION 'CENTER' 	  
	   
          @ 500, 175 BUTTON window_button ;
          CAPTION "OK" ;
          ACTION create_window() ;
          WIDTH 100 ;
          HEIGHT 30 

          @ 500, 350 BUTTON button_tabbuexit ;
          CAPTION "CANCEL" ;
          ACTION win_window.Release  ;
          WIDTH 100 ;
          HEIGHT 30 		
	  	  

   END WINDOW

   CENTER WINDOW win_window
   ACTIVATE WINDOW win_window

RETURN
*:---------------------------------------------*
PROCEDURE create_window

LOCAL _result := '', _charsep := "'", _crlf := chr(13)+chr(10)

_result += '#include <hmg.ch> ' + _crlf + _crlf

_result += 'PROCEDURE main ' + _crlf + _crlf

_result += '   DEFINE WINDOW '
 
 _result += alltrim(win_window.window_2.Value) + ' ;'+ _crlf 
 _result += '      AT ' + alltrim(str(win_window.window_4.Value)) + ', ' + alltrim(str(win_window.window_6.Value)) + ' ; ' + _crlf 
 
 if win_window.window_8.Value != 0
    _result += '      WIDTH ' + alltrim(str(win_window.window_8.Value)) + ' ; ' + _crlf
 endif
 
 if win_window.window_10.Value != 0
    _result += '      HEIGHT ' + alltrim(str(win_window.window_10.Value)) + ' ; ' + _crlf
 endif
  
 if !empty(win_window.window_12.Value)
    _result += '      TITLE ' + _charsep + alltrim(win_window.window_12.Value) + _charsep + ' ; ' + _crlf
 endif
    _result += '      BACKCOLOR  NIL ;'+ _crlf

 if !empty(win_window.window_14.Value)
    _result += '      ICON ' + _charsep + alltrim(win_window.window_14.Value) + _charsep + ' ; ' + _crlf
 endif
 
 do case 
    case win_window.window_15.Value = 1
	    _result += '      MAIN ; ' + _crlf
    case win_window.window_15.Value = 2
	    _result += '      CHILD ; ' + _crlf
    case win_window.window_15.Value = 3
	    _result += '      MODAL ;' + _crlf
    case win_window.window_15.Value = 4
	    _result += '      SPLITCHILD ; ' + _crlf
    case win_window.window_15.Value = 5
	    _result += '      PANEL ; ' + _crlf
 endcase	

if win_window.window_16.Value
   _result += '      NOSHOW ; ' + _crlf
endif
if win_window.window_17.Value
   _result += '      TOPMOST ; ' + _crlf
endif
if win_window.window_18.Value
   _result += '      NOAUTORELEASE ; ' + _crlf
endif
 
if win_window.window_19.Value
   _result += '      NOMINIMIZE ; ' + _crlf
endif
if win_window.window_20.Value
   _result += '      NOMAXIMIZE ; ' + _crlf
endif
if win_window.window_21.Value
   _result += '      NOSIZE ; ' + _crlf
endif
 
if win_window.window_22.Value
   _result += '      NOSYSMENU ; ' + _crlf
endif
if win_window.window_23.Value
   _result += '      NOCAPTION ; ' + _crlf
endif
 
*** on event
if !empty(win_window.window_25.Value) 
   _result += '      ON INIT ' + alltrim(win_window.window_25.Value) + ' ; ' + _crlf
endif
if !empty(win_window.window_27.Value) 
   _result += '      ON RELEASE ' + alltrim(win_window.window_27.Value) + ' ; ' + _crlf
endif

if !empty(win_window.window_29.Value) 
   _result += '      BACKGROUND ' + alltrim(win_window.window_29.Value) + ' ' + _crlf
endif

   _result += ' ' + _crlf
   _result += '      *** ' + _crlf
   _result += '      *** ' + _crlf
   _result += '      *** ' + _crlf
   _result += '      *** ' + _crlf
   _result += '      *** ' + _crlf
   _result += '      *** ' + _crlf
   _result += '      *** ' + _crlf

_result += _crlf + '   END WINDOW ' + _crlf + _crlf + _crlf

if win_window.window_30.Value
   _result += '   CENTER WINDOW ' +  alltrim(win_window.window_2.Value) + ' ' + _crlf
endif

_result += '   ACTIVATE WINDOW ' + alltrim(win_window.window_2.Value) + ' ' + _crlf + _crlf

_result += 'RETURN ' + _crlf
   
System.Clipboard := _result
 
msginfo(_result)
 
RETURN
