//===========================================================================//
// Program......: Calculator
// Programmer...: Marcos Antonio Gambeta
// Created at...: 13/01/2004 11:00:00
// Updated at...: 14/01/2004 00:10:47
//===========================================================================//
// This program is an adaptation of an example that follows
// Visual Basic 5. The original program can be found (for those who have the
// VB5) in the folder: C: \ Program Files \ DevStudio \ VB \ samples \ PGuide \ calc.
// If you improve or expand the capabilities of this calculator, be sure to
// Send a copy to the author's original adaptation. In this case, I. :-)
//===========================================================================//
// Last UpDate at : 09/02/2010
// Updated by     : Paulo Srgio Duro (Vanguarda) - Americana - SP - Brasil
// vanguarda.one@gmail.com
//===========================================================================//
// Cambio de vista y colores nuevos : 12/10/2018
// Actualizado a UTF-8  
// por Mustafa Lpez  Alicante - Espaa
// mustalopez@gmail.com
//---------------------------------------------------------------------------//
// Change of view and new colors: 12/10/2018
// Update to UTF-8
// by Mustafa Lpez Alicante - Spain
// mustalopez@gmail.com
//===========================================================================//
// Added new functions: Memory value now avaliable. Now, you can put entry value from
// keyboard. HotKey for operations like "+" "-" "/" "*" and for manager menory.
// Added function that move the result of expression on ClipBoard of windows, when
// the calc is closed.
//===========================================================================//
// Follow the HotKeys
// C or c = CancelEntry_Click()
// R or r = Cancel_CLick()
// W or w = CancelMemo_Click()
// S or s = ReadMemo_Click()
// M or m = SMemo_Click()
// A or a = AddMemo_Click()
// ESC to Close
//===========================================================================//

#include "hmg.ch"
#include "common.ch"

//===========================================================================//
// Statics variables
//===========================================================================//

Static nOp1,nOp2         // Store the values entered
Static lDecimalFlag      // Indicates whether there is already a decimal point in value
Static nNumOps           // Number of values entered
Static cLastInput        // Store the last key pressed
Static cOpFlag           // Indicates the pending operation
Static cTempReadout
Static nMemo             // Memory Calculator
//===========================================================================//
// Form main
//===========================================================================//

*-------------------------------------------------------*
Function ShowCalc(lRetu_ClipBoard, nInitialValue)
*-------------------------------------------------------*

    SET DECIMALS TO 2

   PRIVATE cInitialValue := "0."
	
   Default lRetu_ClipBoard	:= .T.
   Default nInitialValue	:= 0
   
   cInitialValue := alltrim(str(nInitialValue))

   IF IsWindowDefined( Calc ) 
       MsgStop(  SPACE(3)+"Window is in Use -> Calc","Attention !!!" )
       RETURN NIL
   ENDIF 

   DEFINE WINDOW Calc ;
      AT 0,0                          ;
      WIDTH  220 HEIGHT   263         ;  
      ICON 'Logo'                     ; 
      BACKCOLOR { 250, 250, 250 }     ;
      NOSIZE NOMAXIMIZE NOSYSMENU NOCAPTION;
      FONT "Arial" SIZE 10 ON INIT Form_Load();
      ON RELEASE Get_Value()

      ON KEY ESCAPE ACTION  Calc.Release  

        DEFINE IMAGE Fondo_1  
           ROW 001 ; COL 001 ; WIDTH 219 ; HEIGHT 262  
           PICTURE 'Resource\calc.jpg'       
           STRETCH .T.
        END IMAGE

*-------------------------------------------------  Bolitas ------------------------------------------------------*
   @ 003,176 IMAGE Fondo_2Qx  PICTURE 'Resource\AMIN_ONx.BMP'  WIDTH 019 HEIGHT 019  STRETCH 
   @ 003,198 IMAGE Fondo_3Qx  PICTURE 'Resource\AXIS_ONx.BMP'  WIDTH 018 HEIGHT 018  STRETCH 
*------------------------------------------------------------------------------------------------------------------*
   @ 003,175 LABEL Label_2Qx VALUE "" WIDTH 020 HEIGHT 020  ACTION   MiniMix()  TOOLTIP "Minimize" TRANSPARENT  
   @ 003,197 LABEL Label_3Qx VALUE "" WIDTH 020 HEIGHT 020  ACTION   Closex()   TOOLTIP "Exit"     TRANSPARENT 
*------------------------------------------------------------------------------------------------------------------*
 // visor

    @ 026,013 TEXTBOX ReadOut  VALUE "0." WIDTH 195 HEIGHT 42 RIGHTALIGN NOTABSTOP ;
                DISABLEDBACKCOLOR { 242, 250, 201 } FONT "Arial" SIZE 23 READONLY   

    @ 031,012 TEXTBOX ReadFunc VALUE ""  WIDTH 36  HEIGHT 28 RIGHTALIGN NOTABSTOP ;
                DISABLEDBACKCOLOR { 242, 250, 201 } FONT "Arial" SIZE 16 READONLY        
    @ 026,020 TEXTBOX ReadHide VALUE " "  WIDTH 15  HEIGHT 25 NOTABSTOP ON CHANGE EvalKeys() ON ENTER Operator_Click("=")  INVISIBLE

*--------------------------------------------------------------------------------------------------------------------*

 // 7 8 9 C CE MC 

   @ 080,013 LABEL btnMC  VALUE ""   ACTION CancelMemo_Click()  WIDTH 43 HEIGHT 22 TRANSPARENT    // "MC"    
   @ 110,013 LABEL btnC   VALUE ""   ACTION Cancel_Click()      WIDTH 43 HEIGHT 22 TRANSPARENT    // "C"
   @ 140,013 LABEL btnN7  VALUE ""   ACTION Number_Click(7)     WIDTH 43 HEIGHT 22 TRANSPARENT    // "7"
   @ 140,063 LABEL btnN8  VALUE ""   ACTION Number_Click(8)     WIDTH 43 HEIGHT 22 TRANSPARENT    // "8"
   @ 140,114 LABEL btnN9  VALUE ""   ACTION Number_Click(9)     WIDTH 43 HEIGHT 22 TRANSPARENT    // "9"

 * @ 000,000 LABEL btnCE  VALUE ""   ACTION CancelEntry_Click() WIDTH 43 HEIGHT 43 TRANSPARENT    // "CE" No est Botn Presente en calc.jpg 

 // 4 5 6 + - MR
    
   @ 170,013 LABEL  btnN4  VALUE ""  ACTION Number_Click(4)     WIDTH 43 HEIGHT 22 TRANSPARENT    // "4"
   @ 170,063 LABEL  btnN5  VALUE ""  ACTION Number_Click(5)     WIDTH 43 HEIGHT 22 TRANSPARENT    // "5"
   @ 170,114 LABEL  btnN6  VALUE ""  ACTION Number_Click(6)     WIDTH 43 HEIGHT 22 TRANSPARENT    // "6"
   @ 170,165 LABEL  btnOA  VALUE ""  ACTION Operator_Click("+") WIDTH 43 HEIGHT 22 TRANSPARENT    // "+"
   @ 140,165 LABEL  btnOS  VALUE ""  ACTION Operator_Click("-") WIDTH 43 HEIGHT 22 TRANSPARENT    // "-"
   @ 080,165 LABEL  btnMR  VALUE ""  ACTION ReadMemo_Click()    WIDTH 43 HEIGHT 22 TRANSPARENT    // "MR"

 // 1 2 3 X / MS

   @ 200,013  LABEL btnN1  VALUE ""  ACTION Number_Click(1)     WIDTH 43 HEIGHT 22 TRANSPARENT    // "1"
   @ 200,063  LABEL btnN2  VALUE ""  ACTION Number_Click(2)     WIDTH 43 HEIGHT 22 TRANSPARENT    // "2"
   @ 200,114  LABEL btnN3  VALUE ""  ACTION Number_Click(3)     WIDTH 43 HEIGHT 22 TRANSPARENT    // "3"
   @ 110,165  LABEL btnOM  VALUE ""  ACTION Operator_Click("*") WIDTH 43 HEIGHT 22 TRANSPARENT    // "*"
   @ 110,114  LABEL btnOD  VALUE ""  ACTION Operator_Click("/") WIDTH 43 HEIGHT 22 TRANSPARENT    // "/"

   @ 080,114  LABEL btnMS  VALUE ""  ACTION SMemo_Click()       WIDTH 43 HEIGHT 22 TRANSPARENT    // "MS" 

// 0 . = % M+

   @ 230,013  LABEL btnN0  VALUE ""  ACTION Number_Click(0)     WIDTH 95 HEIGHT 22  TRANSPARENT   //  "0"
   @ 230,114  LABEL btnDot VALUE ""  ACTION Decimal_Click()     WIDTH 43 HEIGHT 22  TRANSPARENT   //  "."  
   @ 200,165  LABEL btnOI  VALUE ""  ACTION Operator_Click("=") WIDTH 43 HEIGHT 51  TRANSPARENT   //  "="   
   @ 110,063  LABEL btnOP  VALUE ""  ACTION Percent_Click()     WIDTH 43 HEIGHT 22  TRANSPARENT   //  "%"  
   @ 080,063  LABEL btnMP  VALUE ""  ACTION AddMemo_Click()     WIDTH 43 HEIGHT 22  TRANSPARENT   //  "M+"


 END WINDOW

   nMemo := 0

   SETWINDOWCURSOR ( Calc.btnN7.Handle, "Resource\SmoothHand.cur" )

 * ----------- Bolitas --------*
  Calc.Fondo_2Qx.VISIBLE := .F.
  Calc.Fondo_3Qx.VISIBLE := .F.
 *-----------------------------*
  Calc.ReadFunc.VISIBLE := .F.

   Calc.Center
   Calc.Activate

   if lRetu_ClipBoard
      To_ClipBoard()
   endif

Return nOp1

*---------------------------------*
FUNCTION Closex()
*---------------------------------*
 Calc.Fondo_3Qx.VISIBLE := .T.
 INKEY(0.95) 
 Calc.Release  
Return

*---------------------------------*
FUNCTION MiniMix()
*---------------------------------*
  Calc.Fondo_2Qx.VISIBLE := .T.
  INKEY(0.95)  
  Calc.Fondo_2Qx.VISIBLE := .F.
  Calc.Minimize 
Return

//---------------------------------------------------------------------------//
// The initialization routine of the form.
// Set the initial values of variables.
//---------------------------------------------------------------------------//
Static Function Form_Load()

    System.ClipBoard := ""

    lDecimalFlag := .f.
    nNumOps := 0
    cLastInput := "NONE"
    cOpFlag := " "
    Calc.Readout.Value := "0."
    nOp1  := 0
    nOp2  := 0
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' of button "C" (CANCEL)
// Reset text control ReadOut and clean the variables
//---------------------------------------------------------------------------//
Static Function Cancel_Click()

   Calc.Readout.Value := "0."
   Calc.ReadFunc.Value := ""
   nOp1 := 0
   nOp2 := 0
   Form_Load()
   Calc.ReadFunc.VISIBLE := .F.
Return Nil

//---------------------------------------------------------------------------//
// Event 'click' of button "CE" (CANCEL ENTRY)
// Cancel value on ReadOut (TextBox)
//---------------------------------------------------------------------------//
Static Function CancelEntry_Click()

    Calc.Readout.Value := "0."
    lDecimalFlag := .f.
    cLastInput := "CE"
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' of button "." (DECIMAL POINT)
// If the last button pressed, was an operator, show on ReadOut (TextBox)
// the value "0.". Case not, add a decimal point into ReadOut
//---------------------------------------------------------------------------//
Static Function Decimal_Click()

    If cLastInput = "NEG"
        Calc.Readout.Value := "-0."
    ElseIf cLastInput <> "NUMS"
        Calc.Readout.Value := "0."
    EndIf
    lDecimalFlag := .t.
    cLastInput := "NUMS"
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' for the buttons of 0 to 9 (NUMBERS KEYS)
// Add the new number into ReadOut (TextBox)
//---------------------------------------------------------------------------//
Static Function Number_Click( nIndex )

    If cLastInput <> "NUMS"
       Calc.Readout.Value := "."
       lDecimalFlag := .f.
    EndIf
    If lDecimalFlag
       Calc.Readout.Value := Calc.Readout.Value + Str(nIndex,1)
    Else
       Calc.Readout.Value := HB_ULEFT(Calc.Readout.Value,At(".",Calc.Readout.Value)-1)+Str(nIndex,1)+"."
    EndIf
    If cLastInput = "NEG"
       Calc.Readout.Value := "-" + Calc.Readout.Value
    endif
    cLastInput = "NUMS"
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' for the button "%" (PERCENT KEY)
// Calculate and show, the percentual of first value
//---------------------------------------------------------------------------//
Static Function Percent_Click()
   Calc.ReadFunc.VISIBLE := .T.

   Calc.Readout.Value := AllTrim(Str(Val(Calc.Readout.Value)/100))
   Calc.ReadFunc.Value := ALLTRIM("%")
   cLastInput := "Ops"
   cOpFlag := "%"
   nNumOps := nNumOps + 1
   lDecimalFlag := .t.
   Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' for the keys "+-*/=" (OPERATOR KEYS)
// If the last button pressed was a number, or part this.
// Increment the nNumOps. If a operand be present, define nOp1.
// If two operand are presenteso, define nOp1 like the result of the
// operation from nOp1 and current value and show the results
//---------------------------------------------------------------------------//
Static Function Operator_Click( cIndex )

    cTempReadout := Calc.Readout.Value
    Calc.ReadFunc.VISIBLE := .T.
    Calc.ReadFunc.Value := ALLTRIM(cIndex)

    If cLastInput = "NUMS"
        nNumOps := nNumOps + 1
    EndIf
    Do Case
    Case nNumOps = 0
        If cIndex = "-" .And. cLastInput <> "NEG"
            Calc.Readout.Value := "-" + Calc.Readout.Value
            cLastInput := "NEG"
        EndIf
    Case nNumOps = 1
        nOp1 := Val( Calc.Readout.Value )
        If cIndex = "-" .And. cLastInput <> "NUMS" .And. cOpFlag <> "="
            Calc.Readout.Value := "-"
            cLastInput := "NEG"
        EndIf
    Case nNumOps = 2
        nOp2 := Val(cTempReadout)
        Do Case
        Case cOpFlag = "+"
           nOp1 := nOp1 + nOp2
        Case cOpFlag = "-"
           nOp1 := nOp1 - nOp2
        Case cOpFlag = "*"
           nOp1 := nOp1 * nOp2
        Case cOpFlag = "/"
           If nOp2 = 0
              MsgInfo("Division by 0 (zero) not allowed.","Calc")
           Else
              nOp1 := nOp1 / nOp2
           EndIf
        Case cOpFlag = "="
           nOp1 := nOp2
        Case cOpFlag = "%"
           nOp1 := nOp1 * nOp2
        Endcase
        Calc.Readout.Value := AllTrim(Str(nOp1))
        nNumOps := 1
    Endcase
    If cLastInput <> "NEG"
        cLastInput := "OPS"
        cOpFlag := cIndex
    EndIf
    Calc.ReadHide.SetFocus()

    System.Clipboard := AllTrim(Str(nOp1))  // Crea poder pegar resultado Control+V

Return Nil

//---------------------------------------------------------------------------//
// This function clean the variable used for add value into memory
//---------------------------------------------------------------------------//
Static Function CancelMemo_Click
	nMemo := 0
     *  SetProperty("Calc","btnMS","FontBold",.F.)     ????  
        SetProperty("Calc","btnMC","FontBold",.F.)       
	Calc.ReadHide.SetFocus()
Return Nil

//---------------------------------------------------------------------------//
// This function show in ReadOut (TextBox) the value in memory (nMemo)
//---------------------------------------------------------------------------//
Static Function ReadMemo_Click

	Local i := 0
	If !Empty(nMemo)
		Calc.Readout.Value := ""
		for i := 1 to HMG_LEN(Alltrim(Str(nMemo)))
			iif(Alltrim(HB_USUBSTR(Alltrim(Str(nMemo)),i,1)) # ".",;
			    Number_Click(Val(Alltrim(HB_USUBSTR(Alltrim(Str(nMemo)),i,1)))),;
				iif(HMG_LEN(Alltrim(Str(nMemo))) # i, Decimal_Click(),))
		next i
	endif
	Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// This function, move to memory (nMemo) the value of ReadOut (TxtBox)
//---------------------------------------------------------------------------//
Static Function SMemo_Click

	if !Empty(Calc.Readout.Value) .and. Val(Calc.Readout.Value) > 0
		nMemo := Val(Calc.Readout.value)
		SetProperty("Calc","btnMS","FontBold",.T.)
		Calc.ReadHide.SetFocus()
	endif

Return Nil

//---------------------------------------------------------------------------//
// This function add the value from ReadOut (TextBox) into memory
//---------------------------------------------------------------------------//
Static Function AddMemo_Click

	if !Empty(Calc.Readout.Value) .and. Val(Calc.Readout.Value) > 0
		nMemo := nMemo + Val(Calc.Readout.Value)
		SetProperty("Calc","btnMS","FontBold",.T.)
	endif
	Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// This function evaluates the keys you type, to perform the functions of
// Calculator keyboard
//---------------------------------------------------------------------------//
Static Function EvalKeys()

	Local c_Keys
	if !Empty(Calc.ReadHide.Value)
		c_Keys := Alltrim(Calc.ReadHide.Value)
		do case
			case c_Keys == "0" .or.;
				 c_Keys == "1" .or.;
				 c_Keys == "2" .or.;
				 c_Keys == "3" .or.;
				 c_Keys == "4" .or.;
				 c_Keys == "5" .or.;
				 c_Keys == "6" .or.;
				 c_Keys == "7" .or.;
				 c_Keys == "8" .or.;
				 c_Keys == "9"
					Number_Click(Val(Alltrim(c_Keys)))
			case c_Keys == "/"
					Operator_Click("/")
			case c_Keys == "*"
					Operator_Click("*")
			case c_Keys == "-"
					Operator_Click("-")
			case c_Keys == "+"
					Operator_Click("+")
			case c_Keys == "."
					Decimal_Click()
			case c_Keys == "C" .or. c_Keys == "c"
					CancelEntry_Click()
			case c_Keys == "R" .or. c_Keys == "r"
					Cancel_Click()
			case c_Keys == "W" .or. c_Keys == "w"
					CancelMemo_Click()
			case c_Keys == "S" .or. c_Keys == "s"
					ReadMemo_Click()
			case c_Keys == "M" .or. c_Keys == "m"
				    ***	SMemo_Click()
			case c_Keys == "A" .or. c_Keys == "a"
					AddMemo_Click()
		end case
		Calc.ReadHide.Value := ""
	endif

Return Nil

//---------------------------------------------------------------------------//
// This function add the result of operation into clipboard
//---------------------------------------------------------------------------//
Static Function To_ClipBoard

	System.Clipboard := Alltrim(Str(nOp1))

Return Nil

//---------------------------------------------------------------------------//
// This function add the result of operation into nOP1 variable
//---------------------------------------------------------------------------//
Static Function Get_Value

       nOp1 := Val(Alltrim(Calc.ReadOut.Value))

Return Nil
//===========================================================================//






